// Code generated by MockGen. DO NOT EDIT.
// Source: ./dao.go

// Package mock is a generated GoMock package.
package mock

import (
	context "context"
	sql "database/sql"
	reflect "reflect"

	gomock "github.com/golang/mock/gomock"
	sqlx "github.com/jmoiron/sqlx"
	params "gitlab.com/golight/dao/params"
	tabler "gitlab.com/golight/entity/tabler"
)

// MockDAOFace is a mock of DAOFace interface.
type MockDAOFace struct {
	ctrl     *gomock.Controller
	recorder *MockDAOFaceMockRecorder
}

// MockDAOFaceMockRecorder is the mock recorder for MockDAOFace.
type MockDAOFaceMockRecorder struct {
	mock *MockDAOFace
}

// NewMockDAOFace creates a new mock instance.
func NewMockDAOFace(ctrl *gomock.Controller) *MockDAOFace {
	mock := &MockDAOFace{ctrl: ctrl}
	mock.recorder = &MockDAOFaceMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockDAOFace) EXPECT() *MockDAOFaceMockRecorder {
	return m.recorder
}

// Begin mocks base method.
func (m *MockDAOFace) Begin() (*sqlx.Tx, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Begin")
	ret0, _ := ret[0].(*sqlx.Tx)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Begin indicates an expected call of Begin.
func (mr *MockDAOFaceMockRecorder) Begin() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Begin", reflect.TypeOf((*MockDAOFace)(nil).Begin))
}

// Create mocks base method.
func (m *MockDAOFace) Create(ctx context.Context, entity tabler.Tabler, opts ...interface{}) error {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, entity}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "Create", varargs...)
	ret0, _ := ret[0].(error)
	return ret0
}

// Create indicates an expected call of Create.
func (mr *MockDAOFaceMockRecorder) Create(ctx, entity interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, entity}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Create", reflect.TypeOf((*MockDAOFace)(nil).Create), varargs...)
}

// Exec mocks base method.
func (m *MockDAOFace) Exec(ctx context.Context, query string, tx *sqlx.Tx, args ...interface{}) (sql.Result, error) {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, query, tx}
	for _, a := range args {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "Exec", varargs...)
	ret0, _ := ret[0].(sql.Result)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Exec indicates an expected call of Exec.
func (mr *MockDAOFaceMockRecorder) Exec(ctx, query, tx interface{}, args ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, query, tx}, args...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Exec", reflect.TypeOf((*MockDAOFace)(nil).Exec), varargs...)
}

// GetCount mocks base method.
func (m *MockDAOFace) GetCount(ctx context.Context, entity tabler.Tabler, condition params.Condition, opts ...interface{}) (uint64, error) {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, entity, condition}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "GetCount", varargs...)
	ret0, _ := ret[0].(uint64)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetCount indicates an expected call of GetCount.
func (mr *MockDAOFaceMockRecorder) GetCount(ctx, entity, condition interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, entity, condition}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetCount", reflect.TypeOf((*MockDAOFace)(nil).GetCount), varargs...)
}

// List mocks base method.
func (m *MockDAOFace) List(ctx context.Context, dest interface{}, table tabler.Tabler, condition params.Condition, opts ...interface{}) error {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, dest, table, condition}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "List", varargs...)
	ret0, _ := ret[0].(error)
	return ret0
}

// List indicates an expected call of List.
func (mr *MockDAOFaceMockRecorder) List(ctx, dest, table, condition interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, dest, table, condition}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "List", reflect.TypeOf((*MockDAOFace)(nil).List), varargs...)
}

// LockTable mocks base method.
func (m *MockDAOFace) LockTable(ctx context.Context, tableName, mode string, tx *sqlx.Tx) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "LockTable", ctx, tableName, mode, tx)
	ret0, _ := ret[0].(error)
	return ret0
}

// LockTable indicates an expected call of LockTable.
func (mr *MockDAOFaceMockRecorder) LockTable(ctx, tableName, mode, tx interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "LockTable", reflect.TypeOf((*MockDAOFace)(nil).LockTable), ctx, tableName, mode, tx)
}

// Ping mocks base method.
func (m *MockDAOFace) Ping(ctx context.Context) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Ping", ctx)
	ret0, _ := ret[0].(error)
	return ret0
}

// Ping indicates an expected call of Ping.
func (mr *MockDAOFaceMockRecorder) Ping(ctx interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Ping", reflect.TypeOf((*MockDAOFace)(nil).Ping), ctx)
}

// Update mocks base method.
func (m *MockDAOFace) Update(ctx context.Context, entity tabler.Tabler, condition params.Condition, operation string, opts ...interface{}) error {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, entity, condition, operation}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "Update", varargs...)
	ret0, _ := ret[0].(error)
	return ret0
}

// Update indicates an expected call of Update.
func (mr *MockDAOFaceMockRecorder) Update(ctx, entity, condition, operation interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, entity, condition, operation}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Update", reflect.TypeOf((*MockDAOFace)(nil).Update), varargs...)
}

// Upsert mocks base method.
func (m *MockDAOFace) Upsert(ctx context.Context, entities []tabler.Tabler, opts ...interface{}) error {
	m.ctrl.T.Helper()
	varargs := []interface{}{ctx, entities}
	for _, a := range opts {
		varargs = append(varargs, a)
	}
	ret := m.ctrl.Call(m, "Upsert", varargs...)
	ret0, _ := ret[0].(error)
	return ret0
}

// Upsert indicates an expected call of Upsert.
func (mr *MockDAOFaceMockRecorder) Upsert(ctx, entities interface{}, opts ...interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	varargs := append([]interface{}{ctx, entities}, opts...)
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Upsert", reflect.TypeOf((*MockDAOFace)(nil).Upsert), varargs...)
}
